// $Id: GandharvaSettings.cpp,v 1.26 2002/08/16 06:41:31 Yoshi Exp $
// Copyright (C) 2000-2002 HOSHINO Yoshifumi
// {vO̓t[E\tgEFAłBρEĔzz GNU GPL o[WQ
// i͂ȍ~jQƂĂB

#define WIN32_LEAN_AND_MEAN
#define STRICT

#include "GandharvaSettings.h"
#include "lsapi.h"
#include <stdlib.h>
#include <windowsx.h>

#include "a2unvlib.h"


/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	RXgN^
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
GandharvaSettings::GandharvaSettings()
{
  int i;
  //xxxxxxxxxxxxxxxxxxxx VXep[^
  m_hbmBack = NULL;
  m_hbmTitle= NULL;
  m_hbmTime = NULL;
  for(i=0; i<=3; i++)
    m_hbmSkin[i] = NULL;

  for(i=0; i<=17; i++)
    m_lpszMouseMap[i%3][(i%9)/3][i/9] = NULL;

  //xxxxxxxxxxxxxxxxxxxx TextLogFont
  //m_TextLogFont.lfHeight;
  m_TextLogFont.lfWidth = 0;
  m_TextLogFont.lfEscapement = 0;
  m_TextLogFont.lfOrientation = 0;
  //m_TextLogFont.lfWeight;
  //m_TextLogFont.lfItalic;
  m_TextLogFont.lfUnderline = FALSE;
  m_TextLogFont.lfStrikeOut = FALSE;
  m_TextLogFont.lfCharSet = DEFAULT_CHARSET;
  m_TextLogFont.lfOutPrecision = OUT_DEFAULT_PRECIS;
  m_TextLogFont.lfClipPrecision = CLIP_DEFAULT_PRECIS;
  m_TextLogFont.lfQuality = DEFAULT_QUALITY;
  m_TextLogFont.lfPitchAndFamily = DEFAULT_PITCH|FF_DONTCARE;
  //m_TextLogFont.lfFaceName[LF_FACESIZE];
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	fXgN^
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
GandharvaSettings::~GandharvaSettings()
{
  int i;
  for(i=0; i<=17; i++)
    if(m_lpszMouseMap[i%3][(i%9)/3][i/9])
      delete m_lpszMouseMap[i%3][(i%9)/3][i/9];

  for(i=0; i<=3; i++)
    if(m_hbmSkin[i]) DeleteBitmap(m_hbmSkin[i]);
  
  if(m_hbmBack)		DeleteBitmap(m_hbmBack);
  if(m_hbmTitle)	DeleteBitmap(m_hbmTitle);
  if(m_hbmTime)		DeleteBitmap(m_hbmTime);
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	ݒ̓ǂݍ
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
void GandharvaSettings::InitSettings()
{
  LPSTR lpszbuf = new char[MAX_LINE_LENGTH];
  char token[5][MAX_RCCOMMAND];
  char *tokens[]={token[0], token[1], token[2], token[3], token[4], 0};
  int tokensnum;
  int i;

  //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
  m_swTextAlignH = ALIGN_LEFT;
  m_uiPlayerType = 2;

  //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
  //xxxxxxxxxxxxxxxxxxxx {ݒxxxxxxxxxxxxxxxxxxxxxxxxxx
  //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
  GetRCString("GandharvaFont", m_TextLogFont.lfFaceName, "MS UI Gothic", LF_FACESIZE);
  m_TextLogFont.lfHeight =GetRCInt("GandharvaFontSize", 16);
  m_FontColor	=GetRCColor("GandharvaFontColor", 0xFFFFFF);
  m_BGColor		=GetRCColor("GandharvaBGColor", 0x000000);
  m_BorderColor	=GetRCColor("GandharvaBorderColor", 0x888888);

  if(GetRCBool("GandharvaForceTransp", TRUE))
    m_TranspColor = m_BGColor;
  else
    m_TranspColor = 0xFF00FF;

  m_bTitleScroll = GetRCBool("GandharvaAutoScroll", TRUE);

  m_TextLogFont.lfItalic = GetRCBool("GandharvaFontItalic", TRUE);
  if(GetRCBool("GandharvaFontBold", TRUE))
    m_TextLogFont.lfWeight = 700;
  else
    m_TextLogFont.lfWeight = 400;

  //m_PosX = GetRCInt("GandharvaX", 0);
  GetRCString("GandharvaX", lpszbuf, "", MAX_RCCOMMAND);
  if(toupper(*lpszbuf) == 'C') {
    m_bXFromCenter=TRUE;
    m_PosX = atoi(lpszbuf+1);
  } else {
    m_bXFromCenter=FALSE;
    m_PosX = atoi(lpszbuf);
  }

  //m_PosY = GetRCInt("GandharvaY", 0);
  GetRCString("GandharvaY", lpszbuf, "", MAX_RCCOMMAND);
  if(toupper(*lpszbuf) == 'C') {
    m_bYFromCenter=TRUE;
    m_PosY = atoi(lpszbuf+1);
  } else {
    m_bYFromCenter=FALSE;
    m_PosY = atoi(lpszbuf);
  }

  m_Width= GetRCInt("GandharvaWidth", 180);
  m_Height=GetRCInt("GandharvaHeight", 20);

  // bitmap
#if 0
  GetRCString("GandharvaBitmap", lpszbuf, "", MAX_PATH);

  if(*lpszbuf){
    m_hbmSkin = LoadLSImage(lpszbuf, NULL);

    //rbg}bvɂ킹ăTCYC
    if(m_hbmSkin)
      GetLSBitmapSize(m_hbmSkin, &m_Width, &m_Height);
  }
#endif

  GetRCLine("GandharvaBitmap", lpszbuf, MAX_LINE_LENGTH, "");
  if(*lpszbuf) {
    tokensnum = TokensCounter(lpszbuf);

    if(tokensnum >4) tokensnum = 1;

    LCTokenize(lpszbuf, tokens, tokensnum, NULL);

    for(i=0; i<tokensnum; i++)
      m_hbmSkin[i] = LoadLSImage(token[i], NULL);

    if(m_hbmSkin[0])
      GetLSBitmapSize(m_hbmSkin[0], &m_Width, &m_Height);
  }
  
  //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
  //xxxxxxxxxxxxxxxxxxxxgݒxxxxxxxxxxxxxxxxxxxxxxxxxx
  //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
  GetRCString("GandharvaDefaultString", m_lpszTitleDefault, "", 128);

  //window style
  m_bAlwaysOnTop = GetRCBool("GandharvaAlwaysOnTop", TRUE);
  m_bVisible = GetRCBool("GandharvaHidden", FALSE);

  //border
  GetRCLine("GandharvaBorderSize", lpszbuf, MAX_RCCOMMAND, "0");
  tokensnum = TokensCounter(lpszbuf);

  if(4 == tokensnum){
    LCTokenize(lpszbuf, tokens, 4, NULL);

    m_nBorderTop   =atoi(token[0]);
    m_nBorderRight =atoi(token[1]);
    m_nBorderBottom=atoi(token[2]);
    m_nBorderLeft  =atoi(token[3]);
  }else
    m_nBorderTop = m_nBorderRight = m_nBorderBottom = m_nBorderLeft = GetRCInt("GandharvaBorderSize", 0);

  //padding
  GetRCLine("GandharvaPadding", lpszbuf, MAX_RCCOMMAND, "0");

  tokensnum = TokensCounter(lpszbuf);

  if(4 == tokensnum){
    LCTokenize(lpszbuf, tokens, 4, NULL);

    m_nPaddingTop   =atoi(token[0]);
    m_nPaddingRight =atoi(token[1]);
    m_nPaddingBottom=atoi(token[2]);
    m_nPaddingLeft  =atoi(token[3]);
  }else
    m_nPaddingTop = m_nPaddingRight = m_nPaddingBottom = m_nPaddingLeft = atoi(lpszbuf);

  //scroll
  m_nScrollInterval = GetRCInt("GandharvaScrollInterval", 500);
  if(m_nScrollInterval < 1)
    m_nScrollInterval = 500;

  m_nScrollStep = GetRCInt("GandharvaScrollStep", 4);
  if(m_nScrollStep < 1)
    m_nScrollStep = 4;

  //prefix suffix
  m_bKeepPrefix = GetRCBool("GandharvaKeepPrefix", TRUE);
  m_bKeepSuffix = GetRCBool("GandharvaKeepSuffix", TRUE);

  //!command mode
  GetRCString("GandharvaCommandMode", lpszbuf, "basic", MAX_RCCOMMAND);

  if(!strcmpi(lpszbuf, "none"))      m_swCmdMode=CMDMODE_NONE;
  if(!strcmpi(lpszbuf, "basic"))     m_swCmdMode=CMDMODE_BASIC;
  if(!strcmpi(lpszbuf, "extension")) m_swCmdMode=CMDMODE_BASIC; //old version

  m_nCmdPlayTimeout = GetRCInt("GandharvaCmdPlayTimeout", 0);

  //text align
  GetRCString("GandharvaTextAlignH", lpszbuf, "left", MAX_RCCOMMAND);

  if(!strcmpi(lpszbuf, "left")) m_swTextAlignH   = ALIGN_LEFT;
  if(!strcmpi(lpszbuf, "right")) m_swTextAlignH  = ALIGN_RIGHT;
  if(!strcmpi(lpszbuf, "center")) m_swTextAlignH = ALIGN_CENTER;

  //xxxxxxxxxxxxxxxxxxxx time display
  memcpy(&m_TimeLogFont, &m_TextLogFont, sizeof(LOGFONT));

  GetRCString("GandharvaTime", lpszbuf, "", MAX_RCCOMMAND);

  if(!stricmp(lpszbuf, "elapsed")){
    m_bTimeEnable = TRUE;
    m_bTimeRemain = FALSE;
  }else if(!stricmp(lpszbuf, "remain")){
    m_bTimeEnable = TRUE;
    m_bTimeRemain = TRUE;
  }else{
    m_bTimeEnable = FALSE;
    m_bTimeRemain = FALSE;
  }

  //font config(init with TITLE font var)
  if(GetRCString("GandharvaTimeFont", lpszbuf, "", LF_FACESIZE))
    strncpy(m_TimeLogFont.lfFaceName, lpszbuf, LF_FACESIZE-1);

  m_TimeFontColor =GetRCColor("GandharvaTimeFontColor", m_FontColor);

  m_TimeLogFont.lfHeight = GetRCInt("GandharvaTimeFontSize",    m_TextLogFont.lfHeight);
  m_TimeLogFont.lfItalic = GetRCBool("GandharvaTimeFontItalic", TRUE);

  if(GetRCBool("GandharvaTimeFontBold", TRUE))
    m_TimeLogFont.lfWeight = 700;
  else
    m_TimeLogFont.lfWeight = 400;

  //time padding
  GetRCLine("GandharvaTimePadding", lpszbuf, MAX_RCCOMMAND, "0");
  tokensnum = TokensCounter(lpszbuf);

  if(4 == tokensnum){
    LCTokenize(lpszbuf, tokens, 4, NULL);

    m_nATPaddingTop   =atoi(token[0]);
    m_nATPaddingRight =atoi(token[1]);
    m_nATPaddingBottom=atoi(token[2]);
    m_nATPaddingLeft  =atoi(token[3]);
  }else
    m_nATPaddingTop = m_nATPaddingRight = m_nATPaddingBottom = m_nATPaddingLeft = atoi(lpszbuf);

  //******************** winamp stuff
  m_bVisibleAmp = GetRCBool("GandharvaHiddenAmp" , FALSE);

  GetRCString("GandharvaPlayerType", lpszbuf, "winamp2", MAX_RCCOMMAND);

  if(!strcmpi(lpszbuf, "winamp2")) m_uiPlayerType = 2;
  if(!strcmpi(lpszbuf, "winamp3")) m_uiPlayerType = 3;
  //xxxxxxxxxxxxxxxxxxxx mouse event mapping

  //.rc Ɏw肪΁Aobt@mۂēǂݍ
  LAYOUT_MOUSE_MAP("GandharvaMouseTTLC", m_lpszMouseMap[ MOUSEMAP_TITLE ][ MOUSEMAP_LEFT  ][ MOUSEMAP_CLICK  ]);
  LAYOUT_MOUSE_MAP("GandharvaMouseTTLD", m_lpszMouseMap[ MOUSEMAP_TITLE ][ MOUSEMAP_LEFT  ][ MOUSEMAP_DBLCLK ]);
  LAYOUT_MOUSE_MAP("GandharvaMouseTTRC", m_lpszMouseMap[ MOUSEMAP_TITLE ][ MOUSEMAP_RIGHT ][ MOUSEMAP_CLICK  ]);
  LAYOUT_MOUSE_MAP("GandharvaMouseTTRD", m_lpszMouseMap[ MOUSEMAP_TITLE ][ MOUSEMAP_RIGHT ][ MOUSEMAP_DBLCLK ]);

  LAYOUT_MOUSE_MAP("GandharvaMouseTMLC", m_lpszMouseMap[ MOUSEMAP_TIME ][ MOUSEMAP_LEFT  ][ MOUSEMAP_CLICK  ]);
  LAYOUT_MOUSE_MAP("GandharvaMouseTMLD", m_lpszMouseMap[ MOUSEMAP_TIME ][ MOUSEMAP_LEFT  ][ MOUSEMAP_DBLCLK ]);
  LAYOUT_MOUSE_MAP("GandharvaMouseTMRC", m_lpszMouseMap[ MOUSEMAP_TIME ][ MOUSEMAP_RIGHT ][ MOUSEMAP_CLICK  ]);
  LAYOUT_MOUSE_MAP("GandharvaMouseTMRD", m_lpszMouseMap[ MOUSEMAP_TIME ][ MOUSEMAP_RIGHT ][ MOUSEMAP_DBLCLK ]);

  LAYOUT_MOUSE_MAP("GandharvaMouseALLC", m_lpszMouseMap[ MOUSEMAP_ALL ][ MOUSEMAP_LEFT  ][ MOUSEMAP_CLICK  ]);
  LAYOUT_MOUSE_MAP("GandharvaMouseALLD", m_lpszMouseMap[ MOUSEMAP_ALL ][ MOUSEMAP_LEFT  ][ MOUSEMAP_DBLCLK ]);
  LAYOUT_MOUSE_MAP("GandharvaMouseALRC", m_lpszMouseMap[ MOUSEMAP_ALL ][ MOUSEMAP_RIGHT ][ MOUSEMAP_CLICK  ]);
  LAYOUT_MOUSE_MAP("GandharvaMouseALRD", m_lpszMouseMap[ MOUSEMAP_ALL ][ MOUSEMAP_RIGHT ][ MOUSEMAP_DBLCLK ]);

  FILE *steprc = LCOpen(NULL);
  if (steprc) {
    int area, button, num;

    while (LCReadNextConfig(steprc, "*GandharvaMouseMapping", lpszbuf, MAX_LINE_LENGTH)) {
      area=button=num = MOUSEMAP_NODATA;

      tokensnum = TokensCounter(lpszbuf);

      if(5 != tokensnum)
        continue;

      LCTokenize(lpszbuf, tokens, 5, NULL);

      if(!strcmpi(token[1], "all"  )) area=MOUSEMAP_ALL;
      if(!strcmpi(token[1], "title")) area=MOUSEMAP_TITLE;
      if(!strcmpi(token[1], "time" )) area=MOUSEMAP_TIME;

      if(!strcmpi(token[2], "right" )) button=MOUSEMAP_RIGHT;
      if(!strcmpi(token[2], "left"  )) button=MOUSEMAP_LEFT;
      if(!strcmpi(token[2], "middle")) button=MOUSEMAP_MIDDLE;

      if(!strcmpi(token[3], "click" )) num=MOUSEMAP_CLICK;
      if(!strcmpi(token[3], "dblclk")) num=MOUSEMAP_DBLCLK;

      //G[΃XLbv
      if(area==MOUSEMAP_NODATA || button==MOUSEMAP_NODATA || num==MOUSEMAP_NODATA)
        continue;

      if(!m_lpszMouseMap[area][button][num]){
        m_lpszMouseMap[area][button][num] = new char[sizeof(token[4])+1];
        strcpy(m_lpszMouseMap[area][button][num], token[4]);
      }
    }
  }
  LCClose(steprc);

  //`ꂽ`FbNĂׂĖ`ȂftHgݒ
  DWORD flag=0;
  for(i=0; i<=17; i++)
    flag |= (DWORD)m_lpszMouseMap[i%3][(i%9)/3][i/9];

  if(!flag) {
    m_lpszMouseMap[ MOUSEMAP_ALL   ][ MOUSEMAP_RIGHT][ MOUSEMAP_CLICK ] = new char[MAX_BANGCOMMAND];
    m_lpszMouseMap[ MOUSEMAP_TITLE ][ MOUSEMAP_LEFT ][ MOUSEMAP_DBLCLK] = new char[MAX_BANGCOMMAND];
    m_lpszMouseMap[ MOUSEMAP_TIME  ][ MOUSEMAP_LEFT ][ MOUSEMAP_CLICK ] = new char[MAX_BANGCOMMAND];

    strcpy(m_lpszMouseMap[ MOUSEMAP_ALL  ][ MOUSEMAP_RIGHT][ MOUSEMAP_CLICK ], "!GandharvaDispMenu");
    strcpy(m_lpszMouseMap[ MOUSEMAP_TITLE][ MOUSEMAP_LEFT ][ MOUSEMAP_DBLCLK], "!GandharvaSndvol");
    strcpy(m_lpszMouseMap[ MOUSEMAP_TIME ][ MOUSEMAP_LEFT ][ MOUSEMAP_CLICK ], "!GandharvaToggleTime");
  }
  //xxxxxxxxxxxxxxxxxxxx ꎞobt@̔j
  delete lpszbuf;
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	TokensCounter
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
#define MAX_TOKENCOUNTER 128

int GandharvaSettings::TokensCounter(LPSTR buffer)
{
  int iptr;
  int counter=1;
  int DQFlag = 0; //DoubleQuoteFlag

  if(!buffer)	return -1;
  if(MAX_TOKENCOUNTER < strlen(buffer)) return -1;

  for(iptr = 0; iptr<MAX_TOKENCOUNTER && *(buffer+iptr) != '\0'; iptr++) {
    if(*(buffer+iptr) == '\"') DQFlag ^=1;
    if(*(buffer+iptr) == ' ' && !DQFlag) counter++;
  }

  return counter;
}



/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	wȉo
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
void GandharvaSettings::PaintBG(HDC hdcdst, int skinIndex)
{
  HDC hdc;
  HBITMAP hbmold;
  
  //xxxxxxxxxxxxxxxxxxxx wi̍쐬͂܂H
  if( !m_hbmBack && !m_hbmSkin[0])
    CreateBG();

  //xxxxxxxxxxxxxxxxxxxx wiorXLRs[
  hdc = CreateCompatibleDC(hdcdst);

  if(m_hbmBack)
    hbmold = SelectBitmap(hdc, m_hbmBack);
  else {
    if(!m_hbmSkin[skinIndex])
      skinIndex = 0;

    hbmold = SelectBitmap(hdc, m_hbmSkin[skinIndex]);
  }

  BitBlt(hdcdst, 0, 0, m_Width, m_Height, hdc, 0, 0, SRCCOPY);

  SelectBitmap(hdc, hbmold);
  DeleteDC(hdc);
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	wi̍쐬
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
void GandharvaSettings::CreateBG()
{
  HDC	hdcScreen, hdcBack;
  HBITMAP hbmBackOld;
  RECT rect;
  HBRUSH hbrush;
  HRGN hrgnFrame,hrgnBg;

  //xxxxxxxxxxxxxxxxxxxx XLgȂ΍쐬KvȂ
  if(m_hbmSkin[0])
    return;

  //xxxxxxxxxxxxxxxxxxxx EChERp`DC,BMP
  hdcScreen = GetDC(m_hWnd);
  hdcBack = CreateCompatibleDC(hdcScreen);
  m_hbmBack = CreateCompatibleBitmap(hdcScreen, m_Width, m_Height);

  hbmBackOld = SelectBitmap(hdcBack, m_hbmBack);

  //xxxxxxxxxxxxxxxxxxxx ǎ؂ăEBhEɒtiȂ񂿂ē߁j
  PaintDesktop(hdcScreen);
  BitBlt(hdcBack, 0, 0, m_Width, m_Height, hdcScreen, 0, 0, SRCCOPY);

  //xxxxxxxxxxxxxxxxxxxx XLȂ
  GetClientRect(m_hWnd, &rect);
  hrgnFrame = CreateRectRgnIndirect(&rect);

  SetRect(&rect, m_nBorderLeft, m_nBorderTop, m_Width -m_nBorderRight, m_Height-m_nBorderBottom);
  hrgnBg = CreateRectRgnIndirect(&rect);

  CombineRgn(hrgnFrame, hrgnFrame, hrgnBg, RGN_DIFF);

  //g
  if(m_BorderColor != m_TranspColor){
    hbrush = CreateSolidBrush(m_BorderColor);
    FillRgn(hdcBack, hrgnFrame, hbrush);
    DeleteBrush(hbrush);
  }
  //wi
  if(m_BGColor != m_TranspColor){
    hbrush = CreateSolidBrush(m_BGColor);
    FillRgn(hdcBack, hrgnBg, hbrush);
    DeleteBrush(hbrush);
  }

  DeleteRgn(hrgnFrame);
  DeleteRgn(hrgnBg);

  //xxxxxxxxxxxxxxxxxxxx ㏈
  SelectBitmap(hdcBack, hbmBackOld);
  DeleteDC(hdcBack);

  ReleaseDC(m_hWnd, hdcScreen);
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	ԕ̃rbg}bv쐬XV
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
void GandharvaSettings::UpdateTimeStrBitmap(long displaytime)
{
  LPSTR lpszbuf = new char[256];

  sprintf(lpszbuf, "%c%02d:%02d",(m_bTimeRemain||displaytime<0)?'-':' ',abs(displaytime/60), abs(displaytime%60));

  if(m_hbmTime)
    DeleteBitmap(m_hbmTime);

  m_hbmTime = CreateTextBitmap(lpszbuf, m_TimeLogFont, m_TimeFontColor, m_TranspColor);

  delete lpszbuf;
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	̃rbg}bv쐬
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
void GandharvaSettings::UpdateTitleStrBitmap(LPSTR lpszTitle)
{
  if(m_hbmTitle)
    DeleteBitmap(m_hbmTitle);
  
  m_hbmTitle = CreateTextBitmap(lpszTitle, m_TextLogFont, m_FontColor, m_TranspColor);
}


/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	̃rbg}bv쐬
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
HBITMAP GandharvaSettings::CreateTextBitmap(LPSTR lpszTextStr, LOGFONT lf, COLORREF fgcolor, COLORREF bgcolor)
{
  HDC hdcwnd,hmemdc;
  HBITMAP hbitmap,hbmold;
  HFONT hfont,hfontold;
  SIZE size;
  long textlen;

  //͓KH
  if(!lpszTextStr)
    return NULL;

  textlen= strlen(lpszTextStr);
  if(!textlen)
    return NULL;

  //rbg}bṽTCY𒲂ׂ
  hmemdc = CreateCompatibleDC(NULL);

  hfont = CreateFontIndirectC(&lf);
  
  hfontold = SelectFont(hmemdc, hfont);
  GetTextExtentPoint32(hmemdc, lpszTextStr, textlen, &size);
  SelectFont(hmemdc, hfontold);
  DeleteDC(hmemdc);

  //߂
  hmemdc = CreateCompatibleDC(NULL);
  hfontold = SelectFont(hmemdc, hfont);

  hdcwnd = GetDC(m_hWnd);
  hbitmap = CreateCompatibleBitmap(hdcwnd, size.cx, size.cy);
  ReleaseDC(m_hWnd, hdcwnd);

  if(hbitmap) {
    hbmold = SelectBitmap(hmemdc, hbitmap);

    //Fw
    SetTextColor(hmemdc, fgcolor);
    SetBkColor(hmemdc, bgcolor);

    //`
    TextOut(hmemdc, 0, 0, lpszTextStr, textlen);

    SelectBitmap(hmemdc, hbmold);
  }
  
  //n
  SelectFont(hmemdc, hfontold);

  DeleteFont(hfont);
  DeleteDC(hmemdc);

  return hbitmap;
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	ԕ\
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
void GandharvaSettings::PaintTime(HDC hdcDst)
{
  int cx,cy;
  HDC hdctemp = CreateCompatibleDC(NULL);
  HBITMAP hbmold = SelectBitmap(hdctemp, m_hbmTime);

  GetLSBitmapSize(m_hbmTime, &cx, &cy);

  TransparentBltLS(hdcDst,
                   m_nATPaddingLeft,
                   m_nATPaddingTop,
                   min(m_Width-(m_nATPaddingRight+m_nATPaddingLeft), cx),
                   min(m_Height-(m_nATPaddingBottom+m_nATPaddingTop), cy),
                   hdctemp,
                   0,
                   0,
                   m_TranspColor);

  SelectBitmap(hdctemp, hbmold);
  DeleteDC(hdctemp);
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	^Cg\iXN[j
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
void GandharvaSettings::PaintText(HDC hdcDst)
{
  HDC hdctext;
  HBITMAP hbmold;
  int dx,dy,dcx,dcy;
  RECT clippedRECT;
  SIZE textSIZE,clippedSIZE;

  int SeparateWidth,SecondOffset;

  if(!m_hbmTitle)
    return;

  GetLSBitmapSize(m_hbmTitle, (int *)&textSIZE.cx, (int *)&textSIZE.cy);

  //xxxxxxxxxxxxxxxxxxxx PaddingSizeɃNbsÖݒ
  clippedRECT.left = m_nPaddingLeft;
  clippedRECT.top = m_nPaddingTop;
  clippedRECT.right = m_Width - m_nPaddingRight;
  clippedRECT.bottom = m_Height - m_nPaddingBottom;

  clippedSIZE.cx = clippedRECT.right - clippedRECT.left;
  clippedSIZE.cy = clippedRECT.bottom - clippedRECT.top;

  //xxxxxxxxxxxxxxxxxxxx XN[̌vZ
  SeparateWidth = clippedSIZE.cx/4;
  SecondOffset = textSIZE.cx - m_nScrollOffset + SeparateWidth;

  //ZJh֐؂n߂ACƌ
  if(SecondOffset <= 0){
    m_nScrollOffset = -SecondOffset;
    SecondOffset = textSIZE.cx - m_nScrollOffset + SeparateWidth;
  }

  //Rs[
  hdctext = CreateCompatibleDC(NULL);
  hbmold = SelectBitmap(hdctext, m_hbmTitle);

  //  [TTTTTTTT]
  //  |---->
  if(m_nScrollOffset < textSIZE.cx){
    dx = clippedRECT.left;
    dy = clippedRECT.top;
    dcx = min(clippedSIZE.cx, textSIZE.cx-m_nScrollOffset);
    dcy = min(clippedSIZE.cy, textSIZE.cy);

    TransparentBltLS(hdcDst, dx, dy, dcx, dcy, hdctext, m_nScrollOffset, 0, m_TranspColor);
  }
  //        |-------->[TTTTTTT]
  //        
  if(SecondOffset < clippedSIZE.cx){
    dx = clippedRECT.left+SecondOffset;
    dy = clippedRECT.top;
    dcx = clippedSIZE.cx-SecondOffset;
    dcy = min(clippedSIZE.cy, textSIZE.cy);

    TransparentBltLS(hdcDst, dx, dy, dcx, dcy, hdctext, 0, 0, m_TranspColor);
  }

  //xxxxxxxxxxxxxxxxxxxxBMP߂
  SelectBitmap(hdctext, hbmold);

  //xxxxxxxxxxxxxxxxxxxxj
  DeleteDC(hdctext);
}




/*ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
	^Cg\iXN[j
ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ*/
void GandharvaSettings::PaintTextNoScroll(HDC hdcDst)
{
  HDC hdctext;
  HBITMAP hbmold;
  int offset,txtcx,txtcy,clipcx,clipcy;

  if(!m_hbmTitle)
    return;

  GetLSBitmapSize(m_hbmTitle, &txtcx, &txtcy);

  //NbsOTCYݒ
  clipcx = m_Width - (m_nPaddingRight+m_nPaddingLeft);
  clipcy = m_Height- (m_nPaddingBottom+m_nPaddingTop);
  
  //align
  switch(m_swTextAlignH){ 
  case ALIGN_RIGHT:
    offset = clipcx - txtcx;
    break;
  case ALIGN_CENTER:
    offset = (clipcx - txtcx)/2;
    break;
  default:
    offset = 0;
    break;
  }

  //xxxxxxxxxxxxxxxxxxxx Rs[
  hdctext = CreateCompatibleDC(NULL);
  hbmold = SelectBitmap(hdctext, m_hbmTitle);

  //
  TransparentBltLS(hdcDst,
                   max(m_nPaddingLeft, m_nPaddingLeft+offset),
                   m_nPaddingTop,
                   min(clipcx,txtcx),
                   min(clipcy,txtcy),
                   hdctext,
                   0,
                   0,
                   m_TranspColor);
  //xxxxxxxxxxxxxxxxxxxxBMP߂
  SelectBitmap(hdctext, hbmold);

  //xxxxxxxxxxxxxxxxxxxxj
  DeleteDC(hdctext);
}
