// $Id: GandharvaSettings.h,v 1.22 2002/08/16 06:41:32 Yoshi Exp $
// Copyright (C) 2000-2002 HOSHINO Yoshifumi
// {vO̓t[E\tgEFAłBρEĔzz GNU GPL o[WQ
// i͂ȍ~jQƂĂB

#ifndef _H_GANDHARVA_SETTINGS
#define _H_GANDHARVA_SETTINGS

#include <windows.h>

//mouse map
enum {
  MOUSEMAP_NODATA=-1,

  MOUSEMAP_ALL=0,
  MOUSEMAP_TIME,
  MOUSEMAP_TITLE,

  MOUSEMAP_LEFT=0,
  MOUSEMAP_RIGHT,
  MOUSEMAP_MIDDLE,

  MOUSEMAP_CLICK=0,
  MOUSEMAP_DBLCLK
};

//!bang command mode
enum {
  CMDMODE_NONE,
  CMDMODE_BASIC,
  CMDMODE_DEBUG
};

//textalign
enum {
  ALIGN_RIGHT,
  ALIGN_LEFT,
  ALIGN_CENTER
};

//timer id
#define TIMERID_RECYCLE_DISPLAY	0x00000001
#define TIMERID_SCROLL_INTERVAL	0x00000002
#define TIMERID_WAIT_PLAY		0x00000003

//macros
#define SWITCH DWORD

#define LAYOUT_MOUSE_MAP(__RCSTR, __VAR) \
  if(GetRCLine(__RCSTR, lpszbuf, 1024, "")){ \
    __VAR = new char[1+strlen(lpszbuf)]; \
    strcpy(__VAR, lpszbuf); \
  }


class GandharvaSettings
{
public:
  GandharvaSettings();
  ~GandharvaSettings();

  void InitSettings();

  //functions
  void CreateBG();
  HBITMAP CreateTextBitmap(LPSTR, LOGFONT, COLORREF, COLORREF);
  void PaintBG(HDC, int skinindex);
  void PaintText(HDC);
  void PaintTextNoScroll(HDC);
  void PaintTime(HDC);
  void UpdateTitleStrBitmap(LPSTR);
  void UpdateTimeStrBitmap(long);
  int  TokensCounter(LPSTR);
  
  //window param
  HINSTANCE	m_hInstance;
  HWND	m_hLitestep;
  HWND	m_hDesktop;
  HWND	m_hWnd;

  HBITMAP	m_hbmBack;
  HBITMAP	m_hbmSkin[4];

  HBITMAP	m_hbmTitle;
  HBITMAP	m_hbmTime;

  //font and color
  LOGFONT m_TextLogFont;

  COLORREF m_FontColor;
  COLORREF m_BGColor;
  COLORREF m_BorderColor;
  COLORREF m_TranspColor;

  //display
  char  m_lpszTitleDefault[130];
  int   m_PosX,m_PosY,m_Width,m_Height;
  BOOL  m_bXFromCenter,m_bYFromCenter;
  int   m_nBorderLeft, m_nBorderRight, m_nBorderTop, m_nBorderBottom;
  int   m_nPaddingLeft, m_nPaddingRight, m_nPaddingTop, m_nPaddingBottom;
  BOOL  m_bTitleScroll;
  BOOL  m_bAlwaysOnTop;
  BOOL  m_bVisible;
  BOOL  m_bVisibleAmp;
  SWITCH    m_swTextAlignH;

  //amp
  BOOL   m_bKeepPrefix;
  BOOL   m_bKeepSuffix;
  SWITCH m_swCmdMode;
  UINT   m_uiPlayerType;
  int    m_nCmdPlayTimeout;

  //scroll
  int m_nScrollInterval;
  int m_nScrollStep;
  int m_nScrollOffset;

  //amptime
  BOOL      m_bTimeEnable;
  BOOL      m_bTimeRemain;
  LOGFONT   m_TimeLogFont;
  COLORREF  m_TimeFontColor;
  int m_nATPaddingLeft, m_nATPaddingRight, m_nATPaddingTop, m_nATPaddingBottom;

  //custom click
  LPSTR m_lpszMouseMap[3][3][2]; //GAA{^Ai_ujNbN
};

#endif //_H_GAHDHARVA_SETTINGS
